<?php

// +-----------------------------------------------------------------------+
// | Piwigo - a PHP based picture gallery                                  |
// +-----------------------------------------------------------------------+
// | Copyright(C) 2008-2009 Piwigo Team                  http://piwigo.org |
// | Copyright(C) 2003-2008 PhpWebGallery Team    http://phpwebgallery.net |
// | Copyright(C) 2002-2003 Pierrick LE GALL   http://le-gall.net/pierrick |
// +-----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or modify  |
// | it under the terms of the GNU General Public License as published by  |
// | the Free Software Foundation                                          |
// |                                                                       |
// | This program is distributed in the hope that it will be useful, but   |
// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
// | General Public License for more details.                              |
// |                                                                       |
// | You should have received a copy of the GNU General Public License     |
// | along with this program; if not, write to the Free Software           |
// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
// | USA.                                                                  |
// +-----------------------------------------------------------------------+

/*****************************************************************************
Parameters ($ec_conf) :
 _ plugin activated ($ec_conf[0] <=> read_ec_conf('activated')) yes/no ;
 _ duplication allowance ($ec_conf[1] <=> read_ec_conf('dup_allow')) :
   0 : no account ;
   1 : all accounts ;
   2 : no account but those specified ;    \
   3 : all accounts but those specified ;  | could be different finally
 _ the number of digits when creating a new code automatically
   ($ec_conf[2] <=> read_ec_conf('auto_code_dg_nb')) ;
 _ whether categories are displayed "cat / under_cat / ..." or
   "cat <CR LF> - under_cat <CR LF> - ..." ($ec_conf[3] <=>
   read_ec_conf('cat_display')) ;
 _ whether the "how to" banner has already been displayed or not
   ($ec_conf[4] <=> read_ec_conf('howto')) ;
 _ what to do in case an unknown code is used with "autolog" parameter
   ($ec_conf[5] <=> read_ec_conf('unknown_code')) :
   0 : nothing ("goto" home page, index.php (not logged in of course)) ;
   1 : redirected to "access denied" page ;
   2 : redirected to an Additional Page precised below.
 _ the id of the Additional Page which must be used in case of usage of an
   unknow code ($ec_conf[6] <=> read_ec_conf('unknown_code_ap_id')).
*****************************************************************************/

global $ec_conf;

// $ec_conf initalization / check
if ($t = mysql_fetch_row(pwg_query("
 SELECT `value`
 FROM `".CONFIG_TABLE."`
 WHERE `param` = 'event_cats';
"))) {
  $ec_conf = explode(',' , $t[0]);
}
else {
  $ec_conf = explode(',' , '0,1,10,0,0,0,0');
  change_ec_conf('activated', 0);
}

/*
 * change_ec_conf($c, $v)
 * updates Event Cats configuration values in the database as well as in
 * $ec_conf.
 *
 * @param
 *   $c : conf value to update ;
 *   $v : value to give to $ec_conf[$c].
 * @return
 *   true or false whether the change was OK or not
 */
function change_ec_conf($c, $v) {
  global $ec_conf;
  switch ($c) {
    case 'activated':
      $ec_conf[0] = $v;
    break;
    case 'dup_allow':
      $ec_conf[1] = $v;
    break;
    case 'auto_code_dg_nb':
      $ec_conf[2] = $v;
    break;
    case 'cat_display':
      $ec_conf[3] = $v;
    break;
    case 'howto':
      $ec_conf[4] = $v;
    break;
    case 'unknown_code':
      $ec_conf[5] = $v;
    break;
    case 'unknown_code_ap_id':
      $ec_conf[6] = $v;
    break;
    default: return false;
  }
  return pwg_query("
   UPDATE `".CONFIG_TABLE."`
   SET `value` = '".implode(',', $ec_conf)."'
   WHERE `param` = 'event_cats';
  ");
}

/*
 * read_ec_conf($c)
 * returns the value in $ec_conf using string keys.
 *
 * @param
 *   $c : conf value to update ;
 * @return
 *   $ec_conf value
 */
function read_ec_conf($c) {
  global $ec_conf;
  switch ($c) {
    case 'activated'         : return $ec_conf[0];
    case 'dup_allow'         : return $ec_conf[1];
    case 'auto_code_dg_nb'   : return $ec_conf[2];
    case 'cat_display'       : return $ec_conf[3];
    case 'howto'             : return $ec_conf[4];
    case 'unknown_code'      : return $ec_conf[5];
    case 'unknown_code_ap_id': return $ec_conf[6];
    default                  : return false;
  }
}

?>