{* <!-- Event Cats (event categories) LucMorizur June - ... 2009 --> *}

{include file='../../../plugins/event_cats/admin/template/header.inc.tpl'}

{* <!-- Whether plugin Additionnal Pages is active or not --> *}
<div style = "text-align:right; font-style:italic;">
  {if $ec_ap_ok}
    {'ec_plugin_ap_ok'|@translate}
    <script type = "text/javascript"><!--
      var ec_ap_ok = true; //-->
    </script>
  {else}
    {'ec_plugin_ap_nok'|@translate}
    <script type = "text/javascript"><!--
      var ec_ap_ok = false; //-->
    </script>
  {/if}
</div>

{* <!-- Form to view codes --> *}
<form class = "filter" method = "post" name = "ec_view_codes" action = "">
  <input type = "hidden" id = "ec_act1_id" name = "ec_act1" />
  <input type = "radio" name = "ec_entry_sel" value = "-1" id = "selection--1" style = "display:none;"/>
  
  <div style = "text-align:center; font-weight:bold; font-size:120%;">
    <a href = "#ec_top" name = "ec_top" title = "{'ec_top_title'|@translate}"><label>{'ec_entry_table_title'|@translate}</label></a><br>
  </div><br>
  
  {* <!-- Table to show codes present in MySQL table --> *}
  <table class = "table2" width = "97%" {* id = "" *}>
    <thead>
      <tr class = "throw">
        <td>{'ec_col_name_entry'|@translate}</td>
        <td>{'ec_col_name_code'|@translate}</td>
        <td>{'ec_col_name_user'|@translate}</td>
        <td>{'ec_col_name_bhvr'|@translate}</td>
        <td>{'ec_col_name_dspl'|@translate}</td>
        <td>{'ec_col_name_actn'|@translate}</td>
      </tr>
    </thead>
    
    {foreach from=$code_list item=code_line name=code_loop}
      <tr class = "{if $smarty.foreach.code_loop.index is odd}row1{else}row2{/if}">
        <td>
          <input type = "radio" name = "ec_entry_sel" value = "{$code_line.id}" id = "selection-{$code_line.id}"
           onclick = "ec_mark_line({$code_line.id});"
          />
          <label for = "selection-{$code_line.id}">{$code_line.id}</label>
          <label id = "ec_url_id_{$code_line.id}" style = "display:none;">{$code_line.code_URL}</label>
        </td>
        <td><label for = "selection-{$code_line.id}" id = "ec_table_code_{$code_line.id}">{$code_line.Code}</label></td>
        <td><label for = "selection-{$code_line.id}" id = "ec_table_usr_{$code_line.id}">{$code_line.Username}</label></td>
        <td><label for = "selection-{$code_line.id}">{$code_line.Action}</label></td>
        <td><label for = "selection-{$code_line.id}">{$code_line.Arg1}</label></td>
        <td>
          {if $code_line.log_OK}
            <a href = "javascript:void(0);" onclick = "ec_check_ds({$code_line.id});">
              <img src = "{$EVNTCATS_URLS.ROOT}icon/disable.png" class = "button"
               alt = "{'ec_url_disable'|@translate}" title = "{'ec_url_disable'|@translate}" />
            </a>
            {if $code_line.Forced == 'true'}
              <a href = "javascript:void(0);" title = "{'ec_url_forced'|@translate}" onclick = "ec_toggle_forced({$code_line.id}, false);">
                <img class = "button" src = "{$EVNTCATS_URLS.ROOT}icon/forced.png"
                 alt = "{'ec_url_forced'|@translate}" title = "{'ec_url_forced'|@translate}"
                />
              </a>
            {else}
              <a href = "javascript:void(0);" title = "{'ec_url_nforced'|@translate}" onclick = "ec_toggle_forced({$code_line.id}, true);">
                <img class = "button" src = "{$EVNTCATS_URLS.ROOT}icon/nforced.png"
                 alt = "{'ec_url_nforced'|@translate}" title = "{'ec_url_nforced'|@translate}"/>
              </a>
              <a href = "javascript:void(0);" title = "{'ec_url_duplicate'|@translate}" onclick = "ec_duplicate_entry({$code_line.id});">
                <img src = "{$EVNTCATS_URLS.ROOT}icon/duplicate.png" class = "button" style = "border:none"
                 alt = "{'ec_url_duplicate'|@translate}" title = "{'ec_url_duplicate'|@translate}" />
              </a>
            {/if}
          {/if}
        </td>
      </tr>
    {/foreach}
  </table>
  
  {* <!-- This is not really a table, looks like a unique cell at the end of previous table,
  to show URL for currently selected line in above table --> *}
  <table class = "table2" width = "97%">
    <tr class = "row2">
      <td style = "padding-top:5px; padding-bottom:5px; font-weight:bold;">
        {'ec_lower_tools_desc'|@translate}
      </td>
      <td style = "{* text-align:center; *}padding-top:5px; padding-bottom:5px;">
        <label title = "{'ec_url_tooltip'|@translate}">
          {'ec_show_URL'|@translate}
          <input type = "text" id = "ec_show_URL" size = "100%" title = "{'ec_url_tooltip'|@translate}" readonly = "readonly" />
        </label><br>
        <br>
        <a
         href = "javascript:void(0);" title = "{'ec_test_tooltip'|@translate}" alt = "{'ec_test_tooltip'|@translate}"
         id = "ec_table_URL" onclick = "return ec_check_tst();" class = "ec_lower_tools"
        />
          <img src = "{$EVNTCATS_URLS.ROOT}icon/url2.png" class = "button"/>
          {'ec_test_text'|@translate}
        </a>
        &nbsp;&nbsp;
        <a href = "javascript:void(0);" onclick = "ec_check_dl();" id = "ec_del_link_id" class = "ec_lower_tools"
         alt = "{'ec_url_delete'|@translate}" title = "{'ec_url_delete'|@translate}"
        >
          <img src = "{$EVNTCATS_URLS.ROOT}icon/delete.png" class = "button"/>
          {'ec_delete_text'|@translate}
        </a>
        &nbsp;&nbsp;
        <a href = "javascript:void(0);" onclick = "ec_check_m();" id = "ec_mod_link_id" class = "ec_lower_tools"
         alt = "{'ec_modify_tooltip'|@translate}" title = "{'ec_modify_tooltip'|@translate}"
        >
          <img src = "{$EVNTCATS_URLS.ROOT}icon/modify.png" class = "button"/>
          {'ec_modify_text'|@translate}
        </a>
      </td>
    </tr>
  </table><br>
</form>

{* <!-- JavaScript functions --> *}
<script type = "text/javascript" src = "{$RACINE_URL}{$EVNTCATS_PATH}admin/template/autolog_entries.js"></script>
<script type = "text/javascript"><!--
  ec_JS_message['ec_confirm_delete']  = "{'ec_confirm_delete'|@translate|@escape:javascript}";
  ec_JS_message['ec_confirm_disable'] = "{'ec_confirm_disable'|@translate|@escape:javascript}";
  ec_JS_message['ec_confirm_test']    = "{'ec_confirm_test'|@translate|@escape:javascript}";
  ec_JS_message['ec_confirm_force']   = "{'ec_confirm_force'|@translate|@escape:javascript}";
  ec_JS_message['ec_clk_entry_miss']  = "{'ec_clk_entry_miss'|@translate|@escape:javascript}";
  ec_init();
//--></script>

{include file='../../../plugins/event_cats/admin/template/footer.inc.tpl'}

{* <!--
--> *}
